
	include 'lisp.s'
	include 'MachineExceptions.a'
	
	import ksignalerr
	
;;; Make an ExceptionInformationPowerPC structure on ths stack; link it into the
;;; xframe list, and return its (fixnum-tagged) address in arg_z.
save_xp:
	stwu sp,-(c_frame.minsiz+RegisterInformationPowerPC.sizeof)(sp)
	stw r3,c_frame.minsiz+RegisterInformationPowerPC.R3.lo(sp)
	la r3,c_frame.minsiz(sp)
	stw rzero,RegisterInformationPowerPC.R0.hi(r3)
	stw r0,RegisterInformationPowerPC.R0.lo(r3)
	stw rzero,RegisterInformationPowerPC.R1.hi(r3)
	stw rzero,RegisterInformationPowerPC.R2.hi(r3)
	stw rzero,RegisterInformationPowerPC.R3.hi(r3)
	stw rzero,RegisterInformationPowerPC.R4.hi(r3)
	stw rzero,RegisterInformationPowerPC.R5.hi(r3)
	stw rzero,RegisterInformationPowerPC.R6.hi(r3)
	stw rzero,RegisterInformationPowerPC.R7.hi(r3)
	stw rzero,RegisterInformationPowerPC.R8.hi(r3)
	stw rzero,RegisterInformationPowerPC.R9.hi(r3)
	stw rzero,RegisterInformationPowerPC.R10.hi(r3)
	stw rzero,RegisterInformationPowerPC.R11.hi(r3)
	stw rzero,RegisterInformationPowerPC.R12.hi(r3)
	stw rzero,RegisterInformationPowerPC.R13.hi(r3)
	stw rzero,RegisterInformationPowerPC.R14.hi(r3)
	stw rzero,RegisterInformationPowerPC.R15.hi(r3)
	stw rzero,RegisterInformationPowerPC.R16.hi(r3)
	stw rzero,RegisterInformationPowerPC.R17.hi(r3)
	stw rzero,RegisterInformationPowerPC.R18.hi(r3)
	stw rzero,RegisterInformationPowerPC.R19.hi(r3)
	stw rzero,RegisterInformationPowerPC.R20.hi(r3)
	stw rzero,RegisterInformationPowerPC.R21.hi(r3)
	stw rzero,RegisterInformationPowerPC.R22.hi(r3)
	stw rzero,RegisterInformationPowerPC.R23.hi(r3)
	stw rzero,RegisterInformationPowerPC.R24.hi(r3)
	stw rzero,RegisterInformationPowerPC.R25.hi(r3)
	stw rzero,RegisterInformationPowerPC.R26.hi(r3)
	stw rzero,RegisterInformationPowerPC.R27.hi(r3)
	stw rzero,RegisterInformationPowerPC.R28.hi(r3)
	stw rzero,RegisterInformationPowerPC.R29.hi(r3)
	stw rzero,RegisterInformationPowerPC.R30.hi(r3)
	stw rzero,RegisterInformationPowerPC.R31.hi(r3)
	
	stw r31,RegisterInformationPowerPC.R31.lo(r3)
	stw r30,RegisterInformationPowerPC.R30.lo(r3)
	stw r29,RegisterInformationPowerPC.R29.lo(r3)
	stw r28,RegisterInformationPowerPC.R28.lo(r3)
	
	stw r27,RegisterInformationPowerPC.R27.lo(r3)
	stw r26,RegisterInformationPowerPC.R26.lo(r3)
	stw r25,RegisterInformationPowerPC.R25.lo(r3)
	stw r24,RegisterInformationPowerPC.R24.lo(r3)
	
	stw r23,RegisterInformationPowerPC.R23.lo(r3)
	stw r22,RegisterInformationPowerPC.R22.lo(r3)
	stw r21,RegisterInformationPowerPC.R21.lo(r3)
	stw r20,RegisterInformationPowerPC.R20.lo(r3)
	
	stw r19,RegisterInformationPowerPC.R19.lo(r3)
	stw r18,RegisterInformationPowerPC.R18.lo(r3)
	stw r17,RegisterInformationPowerPC.R17.lo(r3)
	stw r16,RegisterInformationPowerPC.R16.lo(r3)
	
	stw r15,RegisterInformationPowerPC.R15.lo(r3)
	stw r14,RegisterInformationPowerPC.R14.lo(r3)
	stw r13,RegisterInformationPowerPC.R13.lo(r3)
	stw r12,RegisterInformationPowerPC.R12.lo(r3)
	
	stw r11,RegisterInformationPowerPC.R11.lo(r3)
	stw r10,RegisterInformationPowerPC.R10.lo(r3)
	stw r9,RegisterInformationPowerPC.R9.lo(r3)
	stw r8,RegisterInformationPowerPC.R8.lo(r3)
	
	stw r7,RegisterInformationPowerPC.R7.lo(r3)
	stw r6,RegisterInformationPowerPC.R6.lo(r3)
	stw r5,RegisterInformationPowerPC.R5.lo(r3)
	stw r4,RegisterInformationPowerPC.R4.lo(r3)
	
	stw r2,RegisterInformationPowerPC.R2.lo(r3)
	
	lwz r4,0(sp)
	stw r4,RegisterInformationPowerPC.R1.lo(r3)
	stwu r4,-(FPUInformationPowerPC.sizeof+8)(sp)
	la r4,c_frame.minsiz(sp)
	stfd f0,0*8(r4)
	stfd f1,1*8(r4)
	stfd f2,2*8(r4)
	stfd f3,3*8(r4)
	
	stfd f4,4*8(r4)
	stfd f5,5*8(r4)
	stfd f6,6*8(r4)
	stfd f7,7*8(r4)
	
	stfd f8,8*8(r4)
	stfd f9,9*8(r4)
	stfd f10,10*8(r4)
	stfd f11,11*8(r4)
	
	stfd f12,12*8(r4)
	stfd f13,13*8(r4)
	stfd f14,14*8(r4)
	stfd f15,15*8(r4)
	
	stfd f16,16*8(r4)
	stfd f17,17*8(r4)
	stfd f18,18*8(r4)
	stfd f19,19*8(r4)
	
	stfd f20,20*8(r4)
	stfd f21,21*8(r4)
	stfd f22,22*8(r4)
	stfd f23,23*8(r4)
	
	stfd f24,24*8(r4)
	stfd f25,25*8(r4)
	stfd f26,26*8(r4)
	stfd f27,27*8(r4)
	
	stfd f28,28*8(r4)
	stfd f29,29*8(r4)
	stfd f30,30*8(r4)
	stfd f31,31*8(r4)
	
	mffs f0
	stfd f0,FPUInformationPowerPC.FPSCR(r4)
	lwz r6,FPUInformationPowerPC.Reserved(r4)
	stw r6,FPUInformationPowerPC.FPSCR(r4)
	
	lwz r5,0(sp)
	stwu r5,-(MachineInformationPowerPC.sizeof)(sp)
	mfcr r6
	mfxer r7
	la r5,c_frame.minsiz(sp)
	stw r6,MachineInformationPowerPC.CR(r5)
	stw r7,MachineInformationPowerPC.XER(r5)
	stw rzero,MachineInformationPowerPC.CTR.hi(r5)
	stw loc_pc,MachineInformationPowerPC.CTR.lo(r5)
	stw rzero,MachineInformationPowerPC.LR.hi(r5)
	stw loc_pc,MachineInformationPowerPC.LR.lo(r5)
	stw rzero,MachineInformationPowerPC.LR.hi(r5)
	stw loc_pc,MachineInformationPowerPC.PC.lo(r5)
	
	lwz r7,0(sp)
	stwu r7,-c_frame.minsiz(sp)
	la arg_z,c_frame.minsiz(sp)
	stw r3,ExceptionInformationPowerPC.registerImage(arg_z)
	stw r4,ExceptionInformationPowerPC.FPUImage(arg_z)
	stw r5,ExceptionInformationPowerPC.MachineState(arg_z)
	stw rzero,ExceptionInformationPowerPC.theKind(arg_z)
	stw rzero,ExceptionInformationPowerPC.info(arg_z)
	stw rzero,ExceptionInformationPowerPC.vectorImage(arg_z)
	la r3,24(sp)
	ref_global r4,xframe
	stw arg_z,0(r3)
	stw r4,4(r3)
	set_global r3,xframe
	stw rzero,c_frame.savelr(sp)
	blr

restore_xp:
	ref_global r3,xframe
	lwz arg_z,0(r3)
	lwz r4,4(r3)
	set_global r4,xframe
	lwz r3,ExceptionInformationPowerPC.registerImage(arg_z)
	stw r10,RegisterInformationPowerPC.R10.lo(r3)
	stw r9,RegisterInformationPowerPC.R9.lo(r3)
	; Ok, do the load again ...
restore_xp_from_arg_z:
	lwz r3,ExceptionInformationPowerPC.registerImage(arg_z)
	lwz r4,ExceptionInformationPowerPC.FPUImage(arg_z)
	lwz r5,ExceptionInformationPowerPC.MachineState(arg_z)
	lwz r6,MachineInformationPowerPC.CR(r5)
	lwz r7,MachineInformationPowerPC.XER(r5)
	mtcr r6
	mtxer r7
	
	lwz r5,FPUInformationPowerPC.FPSCR(r4)
	stw r5,FPUInformationPowerPC.Reserved(r4)
	lfd f0,FPUInformationPowerPC.FPSCR(r4)
	mtfsf 0xff,f0
	
	lfd f0,0*8(r4)
	lfd f1,1*8(r4)
	lfd f2,2*8(r4)
	lfd f3,3*8(r4)
	
	lfd f4,4*8(r4)
	lfd f5,5*8(r4)
	lfd f6,6*8(r4)
	lfd f7,7*8(r4)
	
	lfd f8,8*8(r4)
	lfd f9,9*8(r4)
	lfd f10,10*8(r4)
	lfd f11,11*8(r4)
	
	lfd f12,12*8(r4)
	lfd f13,13*8(r4)
	lfd f14,14*8(r4)
	lfd f15,15*8(r4)
	
	lfd f16,16*8(r4)
	lfd f17,17*8(r4)
	lfd f18,18*8(r4)
	lfd f19,19*8(r4)
	
	lfd f20,20*8(r4)
	lfd f21,21*8(r4)
	lfd f22,22*8(r4)
	lfd f23,23*8(r4)
	
	lfd f24,24*8(r4)
	lfd f25,25*8(r4)
	lfd f26,26*8(r4)
	lfd f27,27*8(r4)
	
	lfd f28,28*8(r4)
	lfd f29,29*8(r4)
	lfd f30,30*8(r4)
	lfd f31,31*8(r4)	
	
	lwz r31,RegisterInformationPowerPC.R31.lo(r3)
	lwz r30,RegisterInformationPowerPC.R30.lo(r3)
	lwz r29,RegisterInformationPowerPC.R29.lo(r3)
	lwz r28,RegisterInformationPowerPC.R28.lo(r3)
	
	lwz r27,RegisterInformationPowerPC.R27.lo(r3)
	lwz r26,RegisterInformationPowerPC.R26.lo(r3)
	lwz r25,RegisterInformationPowerPC.R25.lo(r3)
	lwz r24,RegisterInformationPowerPC.R24.lo(r3)
	
	lwz r23,RegisterInformationPowerPC.R23.lo(r3)
	lwz r22,RegisterInformationPowerPC.R22.lo(r3)
	lwz r21,RegisterInformationPowerPC.R21.lo(r3)
	lwz r20,RegisterInformationPowerPC.R20.lo(r3)
	
	lwz r19,RegisterInformationPowerPC.R19.lo(r3)
	lwz r18,RegisterInformationPowerPC.R18.lo(r3)
	lwz r17,RegisterInformationPowerPC.R17.lo(r3)
	lwz r16,RegisterInformationPowerPC.R16.lo(r3)
	
	lwz r15,RegisterInformationPowerPC.R15.lo(r3)
	lwz r14,RegisterInformationPowerPC.R14.lo(r3)
	lwz r13,RegisterInformationPowerPC.R13.lo(r3)
	lwz r12,RegisterInformationPowerPC.R12.lo(r3)
	
	lwz r11,RegisterInformationPowerPC.R11.lo(r3)
	lwz r10,RegisterInformationPowerPC.R10.lo(r3)
	lwz r9,RegisterInformationPowerPC.R9.lo(r3)
	lwz r8,RegisterInformationPowerPC.R8.lo(r3)
	
	lwz r7,RegisterInformationPowerPC.R7.lo(r3)
	lwz r6,RegisterInformationPowerPC.R6.lo(r3)
	lwz r5,RegisterInformationPowerPC.R5.lo(r3)
	lwz r4,RegisterInformationPowerPC.R4.lo(r3)
	
	lwz r2,RegisterInformationPowerPC.R2.lo(r3)
	mr r1,r3
	lwz r3,RegisterInformationPowerPC.R3.lo(r3)
	lwz r1,RegisterInformationPowerPC.R1.lo(r1)
	li rzero,0
	blr


	export box_signed
	export box_unsigned
	export fixnum_overflow
fixnum_overflow: spentry fixnum_overflow
	unbox_fixnum imm0,arg_z
	xoris imm0,imm0,0xc000
box_signed: spentry box_signed
	ref_global extra,heap_limit
	la freeptr,8(freeptr)
	leaf_do_xalloc
	li imm1,one_digit_bignum_header
finish_bignum:
	stw imm1,0(initptr)
	stw imm0,4(initptr)
	la arg_z,fulltag_misc(initptr)
	mr initptr,freeptr
	blr
	
box_unsigned: spentry box_unsigned
	cmpwi imm0,0
	bge box_signed
	ref_global extra,heap_limit
	la freeptr,16(freeptr)
	leaf_do_xalloc
	li imm1,two_digit_bignum_header
	b finish_bignum
	
	
	
xuuo_interr: spentry xuuo_interr
	mflr loc_pc
	la loc_pc,4(loc_pc)
	bl save_xp
	mtlr loc_pc
	lwz imm0,-4(loc_pc)
	clrlslwi arg_y,imm0,6,fixnumshift
	li arg_x,XUUOINTERR
	set_nargs 3
	b ksignalerr
	
xuuo_intcerr: spentry xuuo_intcerr
	mflr loc_pc
	la loc_pc,4(loc_pc)
	bl save_xp
	stwu sp,-lisp_frame.size(sp)
	stw loc_pc,lisp_frame.savelr(sp)
	stw vsp,lisp_frame.savevsp(sp)
	stw fn,lisp_frame.savefn(sp)
	li fn,0
	lwz imm0,-4(loc_pc)
	clrlslwi arg_y,imm0,6,fixnumshift
	li arg_x,XUUOINTCERR
	set_nargs(3)
	bl ksignalerr
	bl restore_xp
	mtlr loc_pc
	blr

trap_wrongnargs: spentry trap_wrongnargs
	li imm2,XWRONGNARGS
	b handle_wrong_nargs
trap_toofewargs: spentry trap_toofewargs
	li imm2,XTOOFEWARGS
	b handle_wrong_nargs
trap_toomanyargs: spentry trap_toomanyargs
	li imm2,XTOOMANYARGS
handle_wrong_nargs:
	vpush_argregs
	stwu sp,-lisp_frame.size(sp)
	add imm0,vsp,nargs
	stw fn,lisp_frame.savefn(sp)
	stw loc_pc,lisp_frame.savelr(sp)
	stw imm0,lisp_frame.savevsp(sp)
	mr fn,nfn
	mr arg_z,nargs
	mr arg_y,fn
	mr arg_x,imm2
	set_nargs 3
	b ksignalerr


trap_intpoll: spentry trap_intpoll
	ref_nrs_value nargs,interrupt_level
	cmpwi cr6,nargs,0
	blelr cr6
	mflr loc_pc
	bl save_xp
	ref_global imm1,db_link
	la imm2,nrs.interrupt_level(rnil)
	vpush rzero
	vpush imm2
	vpush imm1
	set_global vsp,db_link
	li nargs,-1<<fixnumshift
	set_nrs_value nargs,interrupt_level	
	stwu sp,-lisp_frame.size(sp)
	stw fn,lisp_frame.savefn(sp)
	stw loc_pc,lisp_frame.savelr(sp)
	stw vsp,lisp_frame.savevsp(sp)
	li fn,0
	li arg_z,XINTPOLL
	set_nargs 1
	bl ksignalerr
	la sp,lisp_frame.size(sp)
	ref_global imm1,db_link
	lwz imm1,0(imm1)
	set_global imm1,db_link
	bl restore_xp
	mtlr loc_pc
	set_nrs_value rzero,interrupt_level
	blr

;;; Ensure that enough heap space is available to alocate a single CONS cell; leave FREEPTR pointing past
;;; it and INITPTR pointing to the 8 bytes of newly allocated, zeroed memory. 
ensure_cons: spentry ensure_cons
	ref_global extra,heap_limit
	la freeptr,cons.size(freeptr)
	cmplw freeptr,extra
	blelr
allocate_via_xalloc:
	mflr loc_pc
	build_lisp_frame
	bl xalloc_handler
	uuo_xalloc rnil,0,0
	lwz loc_pc,lisp_frame.savelr(sp)
	la sp,lisp_frame.size(sp)
	mtlr loc_pc
	blr
	
;;; Do what a call to xalloc_handler followed by a 'uuo_xalloc rnil,0,0' would do, but don't 
;;; expect a UUO to follow.
finish_alloc: spentry finish_alloc
	mflr loc_pc
	mr extra,sp
	bl save_xp
	set_global r4,xframe
; A 'uuo_xalloc rnil,0,0' instruction  has the value 0x40018b
	lis imm0,0x40			; high 16 bits
	mr imm1,arg_z
	ori imm0,imm0,0x18b	; low 16 bits
	ref_global imm2,xalloc
	ref_global imm3,current_cs
	stw extra,area.active(imm3)
	mtctr imm2
	bctrl
	bl restore_xp_from_arg_z
	mtlr loc_pc
	blr	
		
;;; Ensure the imm0 bytes of heap space are available, GCing if necessary.  (extra should contain room for
;;; headers and alignment.)
ensure_heap_space: spentry ensure_heap_space
	add freeptr,freeptr,extra
	ref_global extra,heap_limit
	cmplw freeptr,extra
	blelr
	b allocate_via_xalloc

;;; likewise
leaf_ensure_heap_space spentry leaf_ensure_heap_space
	b .SPensure_heap_space
	
;;; We've done a store into loc_g.  If the stored value is
;;; potentially younger than loc_g (at a greater heap address),
;;; set a refbit.  (Yes, every once in a while that means
;;; we set the bit when a fixnum is stored, or something like
;;; that.)  Try real hard to preserve all registers.
write_barrier: spentry write_barrier
	lwz rzero,0(loc_g)
	cmplw rzero,loc_g
	ble @done
	stw imm0,-4(sp)
	stw imm1,-8(sp)
	ref_global imm1,heap_start
	sub imm0,loc_g,imm1
	srwi imm0,imm0,dnode_shift
	ref_global imm1,oldspace_dnode_count
	cmplw imm0,imm1
	bge @restore
	mr imm1,imm0
	lis rzero,0x8000
	clrlwi imm0,imm0,27
	srw imm0,rzero,imm0
	srwi imm1,imm1,5
	slwi imm1,imm1,2
	ref_global rzero,refbits
	add imm1,imm1,rzero
	lwz rzero,0(imm1)
	or imm0,rzero,imm0
	stw imm0,0(imm1)
@restore:
	lwz imm1,-8(sp)
	lwz imm0,-4(sp)
@done:
	li rzero,0
	mr loc_g,rzero
	blr

;;; Store key (arg_z) in hash_vector (arg_x) at index (arg_y). If we need to memoize
;;; the store, set a refbit for the hash-vector, too.
;;; This can clobber imm regs and temporaries; it's called as a function.
set_hash_key: spentry set_hash_key
	cmplw arg_z,arg_x
	la imm0,misc_data_offset(arg_y)
	stwx arg_z,arg_x,imm0
	blelr
	add imm0,arg_x,imm0
	ref_global imm4,heap_start
	sub imm0,imm0,imm4
	ref_global imm3,oldspace_dnode_count
	srwi imm0,imm0,dnode_shift
	cmplw imm0,imm3
	bgelr
	clrlwi imm1,imm0,27
	lis imm2,0x8000
	srw imm1,imm2,imm1
	ref_global imm3,refbits
	srwi imm0,imm0,5
	slwi imm0,imm0,2
	lwzx imm2,imm3,imm0
	or imm2,imm1,imm2
	stwx imm2,imm3,imm0
	sub imm0,arg_x,imm4
	srwi imm0,imm0,dnode_shift
	clrlwi imm1,imm0,27
	lis imm2,0x8000
	srw imm1,imm2,imm1
	srwi imm0,imm0,5
	slwi imm0,imm0,2
	lwzx imm2,imm3,imm0
	or imm2,imm1,imm2
	stwx imm2,imm3,imm0
	blr

udfcall: spentry udfcall
	mflr loc_pc
	bl save_xp
	mtlr loc_pc
	li arg_y,XXUDFCALL	         
	set_nargs 2
	b ksignalerr
	
;;; Not continuable
uuovectorbounds: spentry uuovectorbounds
	mflr loc_pc
	la loc_pc,4(loc_pc)
	bl save_xp
	mtlr loc_pc
	lwz imm0,-4(loc_pc)
	clrlslwi arg_y,imm0,6,fixnumshift
	li arg_x,XUUOVECTORBOUNDS
	set_nargs 3
	b ksignalerr

;;; Pretty much has to be continuable
uuoslotunbound: spentry uuoslotunbound
	mflr loc_pc
	la loc_pc,4(loc_pc)
	bl save_xp
	stwu sp,-lisp_frame.size(sp)
	stw loc_pc,lisp_frame.savelr(sp)
	stw vsp,lisp_frame.savevsp(sp)
	stw fn,lisp_frame.savefn(sp)
	li fn,0
	lwz imm0,-4(loc_pc)
	clrlslwi arg_y,imm0,6,fixnumshift
	li arg_x,XUUOSLOTUNBOUND
	set_nargs(3)
	bl ksignalerr
	bl restore_xp
	mtlr loc_pc
	blr

uuounbound: spentry uuounbound	
	mflr loc_pc
	la loc_pc,4(loc_pc)
	bl save_xp
	stwu sp,-lisp_frame.size(sp)
	stw loc_pc,lisp_frame.savelr(sp)
	stw vsp,lisp_frame.savevsp(sp)
	stw fn,lisp_frame.savefn(sp)
	li fn,0
	lwz imm0,-4(loc_pc)
	clrlslwi arg_y,imm0,6,fixnumshift
	li arg_x,XUUOUNBOUND
	set_nargs(3)
	bl ksignalerr
	bl restore_xp
	mtlr loc_pc
	blr

;;; This needs to ffcall into the kernel. 'uuo_xalloc rt,ra,rb' instructions have been used
;;; both to allocate "large" (>= 32KB) objects and to invoke GC-related functionality.  We
;;; want to change the way that allocation works, but still need a way to call into the kernel
;;; if we can't trap into it (to invoke/configure the GC, SAVE-APPLICATION, etc.)
xalloc_handler: spentry xalloc_handler
	mflr loc_pc
	mr extra,sp
	la loc_pc,4(loc_pc)
	bl save_xp
	set_global r4,xframe
	lwz imm0,-4(loc_pc)
	mr imm1,arg_z
	ref_global imm2,xalloc
	ref_global imm3,current_cs
	stw extra,area.active(imm3)
	mtctr imm2
	bctrl
	bl restore_xp_from_arg_z
	mtlr loc_pc
	blr
	
	export cscheck
	
;;; Check for overflow on the cstack (and, soon, the vstack.)
cscheck: spentry cscheck
	ref_global extra,cs_overflow_limit
	cmplw sp,extra
	bgt @check_vstack
	ref_global imm0,current_cs
	lwz imm1,area.softlimit(imm0)
	lwz imm2,area.hardlimit(imm0)
	cmpw extra,imm1
	bne hard_overflow
	set_global imm2,cs_overflow_limit
	li arg_y,XXSTKOVER
	li arg_z,fixnumone	; 1=sp
	set_nargs 2
	b ksignalerr
@check_vstack:
	ref_global extra,vs_overflow_limit
	cmplw vsp,extra
	bgtlr
	ref_global imm0,current_vs
	lwz imm1,area.softlimit(imm0)
	lwz imm2,area.hardlimit(imm0)
	cmpw extra,imm1
	bne hard_overflow
	set_global imm2,vs_overflow_limit
	li arg_y,XXSTKOVER
	li arg_z,13<<fixnumshift
	set_nargs 2
	b ksignalerr
hard_overflow:
	import .SPthrow
	ref_nrs_value temp0,toplcatch
	li temp1,XSTKOVER
	vpush temp0
	vpush temp1
	set_nargs 1
	b .SPthrow



tscheck: spentry tscheck
	ref_global extra,ts_overflow_limit
	cmplw tsp,extra
	bgtlr
	ref_global imm0,current_ts
	lwz imm1,area.softlimit(imm0)
	lwz imm2,area.hardlimit(imm0)
	cmpw extra,imm1
	bne hard_overflow
	set_global imm2,ts_overflow_limit
	li arg_y,XXSTKOVER
	li arg_z,12<<fixnumshift
	set_nargs 2
	b ksignalerr
	
xfpu_exception: spentry xpfu_exception
;;; The instruction that follows the LR is a copy of the FP instruction that caused the exception.
;;; We need to split it into two fixnums: major opcode (in high 6 bits), and everything else.
	mflr loc_pc
	la loc_pc,4(loc_pc)
	bl save_xp
	mtlr loc_pc
	lwz imm0,-4(loc_pc)
	clrlslwi arg_y,imm0,6,fixnumshift
	clrrwi arg_x,imm0,26
	srwi arg_x,arg_x,26-fixnumshift
	li imm0,XFPUEXCEPTION
	vpush imm0
	set_nargs 4
	li imm0,0xd0
	stw imm0,-4(sp)
    lfd f0,-8(sp)
	mtfsf 0xff,f0
	b ksignalerr
	


	end
	
