	macro 
	asm_begin &name
	export &name{ds}
	export .&name{pr}

	csect &name{ds}
	dc.l .&name{pr},TOC{tc0}

	csect .&name{pr}
	function .&name{pr}
	endm

	macro
	asm_end &name
	endf
	toc
	tc &name{tc},&name{ds}
	endm

QT_save record
backlink ds.l 1
crsave	ds.l 1
savelr	ds.l 1
unused	ds.l 2
savetoc	ds.l 1
params	ds.l 8
savevrsave ds.l 1
savenvrs ds.l (32-13)
savefpscr ds.l 2
savef14	ds.l 2
savef15	ds.l 2
savef16	ds.l 2
savef17	ds.l 2
savef18	ds.l 2
savef19	ds.l 2
savef20	ds.l 2
savef21	ds.l 2
savef22	ds.l 2
savef23	ds.l 2
savef24	ds.l 2
savef25	ds.l 2
savef26	ds.l 2
savef27	ds.l 2
savef28	ds.l 2
savef29	ds.l 2
savef30	ds.l 2
savef31	ds.l 2
savev20	ds.l 4
savev21 ds.l 4
savev22	ds.l 4
savev23 ds.l 4
savev24	ds.l 4
savev25 ds.l 4
savev26	ds.l 4
savev27 ds.l 4
savev28	ds.l 4
savev29 ds.l 4
savev30	ds.l 4
savev31 ds.l 4
savevscr ds.l 4
size	equ *
	endr
	
	import altivec_available[RW]
	toc
altivec_available_toc:
	tc altivec_available[TC],altivec_available[RW]

	asm_begin qt_block
	andi. r0,sp,8
	mflr r0
	stw r0,QT_save.savelr(sp)
	bne @1
	stwu sp,-QT_save.size(sp)
	b @2
@1:	stwu sp,-(QT_save.size+8)(sp)
@2:	stmw r13,QT_save.savenvrs(sp)
	lwz r15,altivec_available_toc(rtoc)
	lwz r15,0(r15)
	cmpwi r15,0
	mffs f0
	stfd f0,QT_save.savefpscr(sp)
	stfd f14,QT_save.savef14(sp)
	stfd f15,QT_save.savef15(sp)
	stfd f16,QT_save.savef16(sp)
	stfd f17,QT_save.savef17(sp)
	stfd f18,QT_save.savef18(sp)
	stfd f19,QT_save.savef19(sp)
	stfd f20,QT_save.savef20(sp)
	stfd f21,QT_save.savef21(sp)
	stfd f22,QT_save.savef22(sp)
	stfd f23,QT_save.savef23(sp)
	stfd f24,QT_save.savef24(sp)
	stfd f25,QT_save.savef25(sp)
	stfd f26,QT_save.savef26(sp)
	stfd f27,QT_save.savef27(sp)
	stfd f28,QT_save.savef28(sp)
	stfd f29,QT_save.savef29(sp)
	stfd f30,QT_save.savef30(sp)
	stfd f31,QT_save.savef31(sp)
	beq @altivec_saved
	li r14,QT_save.savev20
	stvx v20,sp,r14
	li r14,QT_save.savev21
	stvx v21,sp,r14
	li r14,QT_save.savev22
	stvx v22,sp,r14
	li r14,QT_save.savev23
	stvx v23,sp,r14
	li r14,QT_save.savev24
	stvx v24,sp,r14
	li r14,QT_save.savev25
	stvx v25,sp,r14
	li r14,QT_save.savev26
	stvx v26,sp,r14
	li r14,QT_save.savev27
	stvx v27,sp,r14
	li r14,QT_save.savev28
	stvx v28,sp,r14
	li r14,QT_save.savev29
	stvx v29,sp,r14
	li r14,QT_save.savev30
	stvx v30,sp,r14
	li r14,QT_save.savev31
	stvx v31,sp,r14
	mfspr r14,256
	stw r14,QT_save.savevrsave(sp)
	mfvscr v0
	li r14,QT_save.savevscr
	stvx v0,sp,r14
@altivec_saved:
	stw rtoc,QT_save.savetoc(sp)
	lwz r12,0(r3)
	mtctr r12
	lwz rtoc,4(r3)
	mr r3,sp
	mr sp,r6
	bctrl
	lwz rtoc,QT_save.savetoc(sp)		; May be bogus
	cmpwi r15,0
	lfd f0,QT_save.savefpscr(sp)
	mtfsf 0xff,f0
	lfd f14,QT_save.savef14(sp)
	lfd f15,QT_save.savef15(sp)
	lfd f16,QT_save.savef16(sp)
	lfd f17,QT_save.savef17(sp)
	lfd f18,QT_save.savef18(sp)
	lfd f19,QT_save.savef19(sp)
	lfd f20,QT_save.savef20(sp)
	lfd f21,QT_save.savef21(sp)
	lfd f22,QT_save.savef22(sp)
	lfd f23,QT_save.savef23(sp)
	lfd f24,QT_save.savef24(sp)
	lfd f25,QT_save.savef25(sp)
	lfd f26,QT_save.savef26(sp)
	lfd f27,QT_save.savef27(sp)
	lfd f28,QT_save.savef28(sp)
	lfd f29,QT_save.savef29(sp)
	lfd f30,QT_save.savef30(sp)
	lfd f31,QT_save.savef31(sp)
	beq @altivec_restored
	li r14,QT_save.savev20
	lvx v20,sp,r14
	li r14,QT_save.savev21
	lvx v21,sp,r14
	li r14,QT_save.savev22
	lvx v22,sp,r14
	li r14,QT_save.savev23
	lvx v23,sp,r14
	li r14,QT_save.savev24
	lvx v24,sp,r14
	li r14,QT_save.savev25
	lvx v25,sp,r14
	li r14,QT_save.savev26
	lvx v26,sp,r14
	li r14,QT_save.savev27
	lvx v27,sp,r14
	li r14,QT_save.savev28
	lvx v28,sp,r14
	li r14,QT_save.savev29
	lvx v29,sp,r14
	li r14,QT_save.savev30
	lvx v30,sp,r14
	li r14,QT_save.savev31
	lvx v31,sp,r14
	li r14,QT_save.savevscr
	lvx v0,sp,r14
	mtvscr v0
	lwz r14,QT_save.savevrsave(sp)
	mtspr 256,r14
@altivec_restored:
	lmw r13,QT_save.savenvrs(sp)
	lwz sp,QT_save.backlink(sp)
	lwz r0,QT_save.savelr(sp)
	mtlr r0
	blr
	asm_end qt_block
	
	asm_begin qt_start
	import .qt_error
	mtctr r17
	mr r12,r17
	mr r3,r14
	mr r4,r15
	mr r5,r16
	bctrl
	b .qt_error
	asm_end qt_start

	;; NewThreadEntryUPP has consed up a trampoline.  Invoke it.
	;; (We can't easily call a "raw" entrypoint from CFM C code.)
	
	asm_begin invoke_user_function
	mtctr r4
	mr r12,r4
	bctr
	asm_end invoke_user_function

	

	


	
